searchNodes=[{"doc":"Documentation for Vigil. As a gatekeeper for your GraphQL API, Vigil disallows introspection of a GraphQL schema and sanitizes error messages to be completely generic and not reveal information about your schema. This plug disables graphql introspection by returning a Forbidden status if an introspection query of any kind is contained in the query string. It also returns a Not Found if an request is made on a non-existent field, and Bad Request if required arguments are missing. For more information about introspection queries see the GraphQL documentation here .","ref":"Vigil.html","title":"Vigil","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"Vigil.html#call/2","title":"Vigil.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"Vigil.html#init/1","title":"Vigil.init/1","type":"function"},{"doc":"","ref":"Vigil.html#t:token/0","title":"Vigil.token/0","type":"type"},{"doc":"A specialized log formatter for Vigil","ref":"Vigil.LogFormatter.html","title":"Vigil.LogFormatter","type":"module"},{"doc":"This function is intended to be used throughout the plug (including in callbacks) to log any exceptions as they occur. It is neccessary to abstract this away into its own function because the sanitize module will be called outside of the general try/rescue at the root of the plug, because it is implemented as a callback. This function allows us to have the same logging schema accross the entire plug, even though we can't make guarantees about when certain modules will be called or in what context.","ref":"Vigil.LogFormatter.html#log/3","title":"Vigil.LogFormatter.log/3","type":"function"},{"doc":"Utilities for determining whether GraphQL query strings are introspection queries.","ref":"Vigil.Query.html","title":"Vigil.Query","type":"module"},{"doc":"When passed a connection of the type Plug.Conn.t(), parses out the &quot;query&quot; key from the :body_params or :query_params of the conn and returns true if the query is not a GraphQL introspection query. Reserved GraphQL introspection query strings are defined here .","ref":"Vigil.Query.html#safe?/1","title":"Vigil.Query.safe?/1","type":"function"},{"doc":"This module provides a callback to be used in the Plug.Conn.register_before_send/1 function. It checks whether the connection contains an errored response from the GraphQL API. If it does, the repsponse is sanitized into a generic HTTP response before it is returned to the user.","ref":"Vigil.Sanitizer.html","title":"Vigil.Sanitizer","type":"module"},{"doc":"Takes in a %Plug.Conn{} and if it has sensitive GraphQL errors, sanitize them before continuing with the remainder of the pipeline. If an exception occurs, this isn't worth crashing for. Return the connection unchanged, and log what happened. As a note, the call function in the root of this project provides a similar general try/rescue, but it is bypassed when this function is used as a callback with the Plug.Conn.register_before_send/1 function. Therefore it becomes necessary to include another general try catch here to prevent exceptions from bubbling up to the remainder of the pipeline.","ref":"Vigil.Sanitizer.html#sanitize_response/2","title":"Vigil.Sanitizer.sanitize_response/2","type":"function"},{"doc":"Utilities for validating simple tokens","ref":"Vigil.Token.html","title":"Vigil.Token","type":"module"},{"doc":"Accepts a %Plug.Conn{} struct containing the header token and the token to compare it to","ref":"Vigil.Token.html#valid?/2","title":"Vigil.Token.valid?/2","type":"function"}]